namespace CMSMicroservice.Application.FactorDetailsCQ.Queries.GetFactorDetails;
public class GetFactorDetailsQueryValidator : AbstractValidator<GetFactorDetailsQuery>
{
    public GetFactorDetailsQueryValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetFactorDetailsQuery>.CreateWithOptions((GetFactorDetailsQuery)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
